"use strict";

var _iniettore = _interopRequireWildcard(require("../../src/iniettore"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

describe('Given a context with a registered constructor', () => {
  describe('when requesting the corresponding mapping name', () => {
    it('should create a new instance', done => {
      class Foo {
        constructor() {
          expect(this).toBeInstanceOf(Foo);
          done();
        }

      }

      var rootContext = _iniettore.default.create(map => {
        map('foo').to(Foo).as(_iniettore.CONSTRUCTOR);
      });

      rootContext.get('foo');
    });
    describe('the created instance constructor', () => {
      class Bar {
        static hello() {}

      }

      it('should have the static method/properties of the original constructor', () => {
        var rootContext = _iniettore.default.create(map => {
          map('bar').to(Bar).as(_iniettore.CONSTRUCTOR);
        });

        var bar = rootContext.get('bar');
        expect(bar.constructor).toEqual(Bar);
        expect(bar.constructor).toHaveProperty('hello');
      });
    });
  });
});