"use strict";

var _iniettore = _interopRequireWildcard(require("../../src/iniettore"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

describe('Given a provider and a contructor', () => {
  var provider = jest.fn();
  var constructorSpy = jest.fn();

  class Foo {
    constructor(...args) {
      constructorSpy.apply(null, args);
    }

  }

  beforeEach(() => {
    provider.mockClear();
    constructorSpy.mockClear();
  });
  describe('when registering them as EAGER, SINGLETONs', () => {
    it('should create instances straightaway', () => {
      _iniettore.default.create(map => {
        map('number').to(42).as(_iniettore.VALUE);
        map('bar').to(provider).as(_iniettore.EAGER, _iniettore.SINGLETON, _iniettore.PROVIDER).injecting('number');
        map('foo').to(Foo).as(_iniettore.EAGER, _iniettore.SINGLETON, _iniettore.CONSTRUCTOR).injecting('number');
      });

      expect(provider).toHaveBeenCalledWith(42);
      expect(constructorSpy).toHaveBeenCalledWith(42);
    });
  });
});