"use strict";

var _iniettore = _interopRequireWildcard(require("../../src/iniettore"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

describe('Given a context with a registered function', () => {
  describe('when the function has some dependencies', () => {
    const BAR = {};
    it('should return a partial application of the function', () => {
      function foo(bar, param1) {
        expect(bar).toBe(BAR);
        expect(param1).toEqual(42);
      }

      const rootContext = _iniettore.default.create(map => {
        map('bar').to(BAR).as(_iniettore.VALUE);
        map('foo').to(foo).as(_iniettore.FUNCTION).injecting('bar');
      });

      const partialApplicationOfFoo = rootContext.get('foo');
      partialApplicationOfFoo(42);
    });
  });
});