"use strict";

var _iniettore = _interopRequireWildcard(require("../../src/iniettore"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

var foo = 42;
var context;
describe('Given a context', () => {
  describe('with a registered constructor', () => {
    describe('and with implicit dependency annotations', () => {
      describe('when requesting the corresponding mapping name', () => {
        it('should create an instance of it providing the requested dependencies', () => {
          class Bar {
            constructor($foo) {
              expect($foo).toBe(foo);
            }

          }

          context = _iniettore.default.create(function (map) {
            map('foo').to(foo).as(_iniettore.VALUE);
            map('bar').to(Bar).as(_iniettore.CONSTRUCTOR);
          });
          context.get('bar');
        });
      });
    });
  });
  describe('with a registered provider', () => {
    describe('with implicit dependency annotations', () => {
      describe('when requesting the corresponding mapping name', () => {
        it('should invoke it providing the requested dependencies', () => {
          var provider = function ($foo) {
            expect($foo).toBe(foo);
          };

          context = _iniettore.default.create(function (map) {
            map('foo').to(foo).as(_iniettore.VALUE);
            map('bar').to(provider).as(_iniettore.PROVIDER);
          });
          context.get('bar');
        });
      });
    });
  });
  describe('with a registered provider', () => {
    describe('with implicit dependency annotations one of which is the context itself', () => {
      describe('when requesting the corresponding mapping name', () => {
        it('should invoke it providing the requested dependencies', () => {
          var provider = function ($foo, $context) {
            expect($foo).toBe(foo);
            expect($context).toBe(context);
          };

          context = _iniettore.default.create(function (map) {
            map('foo').to(foo).as(_iniettore.VALUE);
            map('bar').to(provider).as(_iniettore.PROVIDER);
          });
          context.get('bar');
        });
      });
    });
  });
  describe('with a registered function', () => {
    describe('with implicit dependency annotations', () => {
      describe('when requesting the corresponding mapping name', () => {
        it('should return a partial application of the function', () => {
          var func = function ($foo, param1) {
            expect($foo).toBe(foo);
            expect(param1).toBe('hello');
          };

          var bar;
          context = _iniettore.default.create(function (map) {
            map('foo').to(foo).as(_iniettore.VALUE);
            map('bar').to(func).as(_iniettore.FUNCTION);
          });
          bar = context.get('bar');
          bar('hello');
        });
      });
    });
  });
});