"use strict";

var _iniettore = _interopRequireWildcard(require("../../src/iniettore"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

describe('Given a context with a registered provider', () => {
  var rootContext;
  var BAR_1 = {
    bar: 1,
    dispose: jest.fn()
  };
  var BAR_2 = {
    bar: 2,
    dispose: jest.fn()
  };
  var providerStub = jest.fn();
  beforeEach(() => {
    providerStub.mockClear();
    providerStub.mockReturnValueOnce(BAR_1).mockReturnValueOnce(BAR_2);
    BAR_1.dispose.mockClear();
    BAR_2.dispose.mockClear();
  });
  describe('when requesting multiple times the corresponding alias', () => {
    it('should invoke the provider function at every request with his dependencies', () => {
      var result;
      rootContext = _iniettore.default.create(map => {
        map('foo').to(42).as(_iniettore.VALUE);
        map('bar').to(providerStub).as(_iniettore.PROVIDER).injecting('foo');
      });
      result = rootContext.get('bar');
      expect(result).toBe(BAR_1);
      expect(providerStub).toHaveBeenCalledTimes(1);
      expect(providerStub).toHaveBeenCalledWith(42);
      result = rootContext.get('bar');
      expect(result).toBe(BAR_2);
      expect(providerStub).toHaveBeenCalledTimes(2);
      expect(providerStub).toHaveBeenCalledWith(42);
    });
  });
});