"use strict";

var _iniettore = _interopRequireWildcard(require("../../src/iniettore"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

describe('Given a context with a registered provider', () => {
  var providerSpy = jest.fn();
  var rootContext;
  describe('when requesting it with some transient dependencies ', () => {
    var TRANSIENT_DEPENDENCIES = {
      baz: 84
    };
    beforeAll(() => {
      rootContext = _iniettore.default.create(map => {
        map('bar').to(42).as(_iniettore.VALUE);
        map('foo').to(providerSpy).as(_iniettore.PROVIDER).injecting('bar', 'baz');
      });
    });
    beforeEach(() => {
      providerSpy.mockClear();
    });
    it('should also use them to resolve the final provider dependencies', () => {
      var foo = rootContext.using(TRANSIENT_DEPENDENCIES).get('foo');
      expect(providerSpy).toHaveBeenCalledWith(42, 84);
    });
    it('should not leave any transient dependency registered in the rootContext', () => {
      var foo = rootContext.using(TRANSIENT_DEPENDENCIES).get('foo');

      function testCase() {
        rootContext.get('baz');
      }

      expect(testCase).toThrow(Error);
    });
  });
});